%     AERO LOAD - программа для нагружения агрегатов самолета распределенной нагрузкой
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function DB_Field_Add_Record(Field_ID, Item_ID, Item_Value)

global ErrCode;

global DB_FIELDS;
global AT_FIELDS;

global Field_Zero_Record_Tolerance;
global Field_Nonzero_Record_Tolerance;

% Проверка существования в базе поля
if (~DB_Field_Exist(Field_ID))
    fprintf (1, '\nОшибка функции DB_Field_Add_Record: поле с номером %i отсутствует в базе !\n', Field_ID);
    ErrCode = -1;
    return;
end

% Проверка параметра Item_ID
if (Item_ID <=0)
    fprintf (1, '\nОшибка функции DB_Field_Add_Record: недопустимое значение параметра Item_ID !\n');
    ErrCode = -1;
    return;
end

% Проверка размерности
if (~isempty(Item_Value))
    if (size(Item_Value,1) ~= DB_FIELDS{AT_FIELDS(Field_ID)}.Dim)
        fprintf (1, '\nОшибка функции DB_Field_Add_Record: размерность величины Item_Value не совпадает с размерностью поля %i !\n', Field_ID);
        ErrCode = -1;
        return;
    end
    if (size(Item_Value,2) ~= 1)
        fprintf (1, '\nОшибка функции DB_Field_Add_Record: недопустимое число столбцов величины Item_Value !\n');
        ErrCode = -1;
        return;
    end
end

% Запись данных в поле
if (isempty(DB_FIELDS{AT_FIELDS(Field_ID)}.ID_data))
    
    % Первая запись
    
    % Заполнение значения по умолчанию
    DB_FIELDS{AT_FIELDS(Field_ID)}.Default = Item_Value;
    
    % Создание первой записи в базе и присвоение отметки об удалении записи
    DB_FIELDS{AT_FIELDS(Field_ID)}.ID_data{1,1} = -1;
    DB_FIELDS{AT_FIELDS(Field_ID)}.Value_data{1,1} = Item_Value;
    
    % Создание пустой записи в адресной таблице
    DB_FIELDS{AT_FIELDS(Field_ID)}.AT{1,1} = [];
    
else
    
    % Не первая запись
    
    % Проверка существования записи с тем же Item_ID
    if (size(DB_FIELDS{AT_FIELDS(Field_ID)}.AT,1) >= Item_ID)
        if (~isempty(DB_FIELDS{AT_FIELDS(Field_ID)}.AT{Item_ID}))
            fprintf (1, '\nОшибка функции DB_Field_Add_Record: данные для объекта с номером %i уже содержатся в базе !\n', Item_ID);
            ErrCode = -1;
            return;
        end
    end
    
    % Проверка значения Item_Value на совпадение со значением по умолчанию
    Coincidence_flag = 1;
    
    if (isempty(DB_FIELDS{AT_FIELDS(Field_ID)}.Default))
        
        if (~isempty(Item_Value))
            Coincidence_flag = 0;
        end
        
    else
        
        if (isempty(Item_Value))
            Coincidence_flag = 0;
        else
            for i=1:DB_FIELDS{AT_FIELDS(Field_ID)}.Dim
                
                if (DB_FIELDS{AT_FIELDS(Field_ID)}.Default(i) == 0)
                    if (abs(Item_Value(i)) > Field_Zero_Record_Tolerance)
                        Coincidence_flag = 0;
                        break;
                    end
                else
                    if (abs(DB_FIELDS{AT_FIELDS(Field_ID)}.Default(i) - Item_Value(i)) > Field_Nonzero_Record_Tolerance * abs(DB_FIELDS{AT_FIELDS(Field_ID)}.Default(i)))
                        Coincidence_flag = 0;
                        break;
                    end
                end

            end
        end
        
    end
    
    % Создание новой записи в случае несовпадения со значением по умолчанию
    if (Coincidence_flag == 0)
        
        % Следующий индекс в базе
        Next_DB_index = size(DB_FIELDS{AT_FIELDS(Field_ID)}.ID_data,1) + 1;
        
        % Создание записи в базе
        DB_FIELDS{AT_FIELDS(Field_ID)}.ID_data{Next_DB_index,1} = Item_ID;
        DB_FIELDS{AT_FIELDS(Field_ID)}.Value_data{Next_DB_index,1} = Item_Value;
        DB_FIELDS{AT_FIELDS(Field_ID)}.AT{Item_ID,1} = Next_DB_index;
        
    end
    
end
